#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cctype>
#include <cstring>
#include <string>
#include <limits>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <list>

using namespace std;

char S[20];

int Y;

vector<int> dates;

int prvnileden[4000];

bool is_leap_year(int y){
 return (y%400==0 || (y%4==0 && y%100!=0));
}

//const int months[12]={31,28,31,30,31,30,31,31,30,31,30,31};
const int months_l[12]={31,29,31,30,31,30,31,31,30,31,30,31};


int mday_to_yday(int d, int m){
  int day = 0;
  for(int i=0;i<m-1;++i){    
    day+=months_l[i];
    
  }
  
  return day+d-1;
  
}

int easter_monday(){
  int golden, solar, lunar, p;
  
  golden = Y%19 + 1;
  solar = (Y-1600)/100 - (Y-1600)/400;
  lunar = ((((Y-1400)/100)*8)/25);
  p = (3003 - (11*golden) + solar - lunar)%30;
  if(p==29 || (p==28 && golden>11))p--;
  
  int pfm = p + is_leap_year(Y)?0:-1 + mday_to_yday(21,3);//paschall full moon
  pfm++;
  int d = prvnileden[Y] + pfm;
  d%=7;
  while (d != 6) {
   d++; d%=7;
   pfm++; 
  }
  pfm++;
  return pfm;
  
}


int main()
{
  prvnileden[2010] = 4;
  int p = 4;
  for(int i=2011;i<3001;++i){
    p+=is_leap_year(i-1)?366:365;
    p%=7;
    prvnileden[i] = p;
  }
  p = 4;
  for (int i = 2009; i >= 1600;i--) {
     p-=is_leap_year(i)?366:365;
     p%=7;
     prvnileden[i] = p; 
  }
  
  
  while(1){
    
    if(scanf("%s",S)!=1)break;
    
    dates.clear();
    
    bool range = false;
    int range_from = 0;
    while(1){
      int month, mday;
      scanf("%d.%d.",&mday,&month);
      int day=mday_to_yday(mday, month);
      char c = getchar();
      if(c==' ') {
        if(range){
          for(int i = range_from;i<=day;++i){
            dates.push_back(i);
            range =false;
          }
        }
        else{
          dates.push_back(day);
        }
        break;
      }
      else if(c == '-'){
        range = true;
        range_from = day;
      }
      else if(c==','){
        if(range){
          for(int i = range_from;i<=day;++i){
            dates.push_back(i);
            range =false;
          }
        }
        else{
          dates.push_back(day);
        }
      }
      
    }
    scanf("%d ",&Y);
    int res = 0;
    bool leap=is_leap_year(Y);
    int leap_day = mday_to_yday(29,2);
    int svatky[12] = {
      0, mday_to_yday(1,5)-leap?0:1, mday_to_yday(8,5)-leap?0:1, mday_to_yday(5,7)-leap?0:1, mday_to_yday(6,7)-leap?0:1,
              mday_to_yday(28,9)-leap?0:1,mday_to_yday(28,10)-leap?0:1,mday_to_yday(17,11)-leap?0:1,
                           mday_to_yday(24,12)-leap?0:1,mday_to_yday(25,12)-leap?0:1,mday_to_yday(26,12)-leap?0:1};
    for(int i=0;i<dates.size();++i){
      int d = dates[i];
      if (!leap && d == leap_day) continue;
      if(!leap && d>leap_day)
         --d;
      int dinw = (d + prvnileden[Y]) % 7;
      int c = 0;
      bool yes = false;
      for (;S[c] != '\0' && !yes;c++) {
        if (S[c] >= '1' && S[c] <= '7') {
         int dayinw = S[c] - '1';
         if (dayinw == dinw) yes = true;
        }
        else if (S[c] == 't') {
          if (dinw == 6) yes = true;
          if (easter_monday() == d) yes = true;
          for (int j = 0; j < 11; j++) {
           if (d == svatky[j]) { yes = true; break; }
          }
        }
        else if (S[c] == 'w') {
          if (dinw >= 5) continue; 
          if (easter_monday() == d) continue;
          bool b = false;
          for (int j = 0; j < 11; j++) {
            if (d == svatky[j]) { b = true;; break; }
          }
          if (!b) yes = true;
        }
        else if (S[c] == 'a') {
          int d2 = d - 1;
          if (dinw >= 5) continue;
          if (d2 == -1) {
            continue;
          }
          if ((dinw - 1)%7 == 6) yes = true;
          if (easter_monday() == d2) yes = true;
          for (int j = 0; j < 11; j++) {
            if (d2 == svatky[j]) { yes = true; break; }
          }
        }
      }
      if (yes) {
        printf("day %d\n", d);
        res++;
      }
    }
    printf("%d\n", res);
    
  } 
  return 0;
}

